GNU bug report logs - #44622
[PATCH v2] speedbar bugfix: only replace '~/' when it appears at the beginning of the path

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: emacs; Reported by: Daniel Lenski <dlenski@HIDDEN>; merged with #44608; dated Fri, 13 Nov 2020 18:55:01 UTC; Maintainer for emacs is bug-gnu-emacs@HIDDEN.
Removed tag(s) patch and fixed. Request was from Andreas Schwab <schwab@HIDDEN> to control <at> debbugs.gnu.org. Full text available.
bug No longer marked as fixed in versions 28.1 and reopened. Request was from Debbugs Internal Request <help-debbugs@HIDDEN> to internal_control <at> debbugs.gnu.org. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 14 Nov 2020 16:31:53 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Nov 14 11:31:53 2020
Received: from localhost ([127.0.0.1]:51759 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kdySv-0000eZ-25
	for submit <at> debbugs.gnu.org; Sat, 14 Nov 2020 11:31:53 -0500
Received: from lists.gnu.org ([209.51.188.17]:54868)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <whitebox@HIDDEN>) id 1kdySt-0000ck-2b
 for submit <at> debbugs.gnu.org; Sat, 14 Nov 2020 11:31:51 -0500
Received: from eggs.gnu.org ([2001:470:142:3::10]:43736)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <whitebox@HIDDEN>)
 id 1kdySs-0000LM-Pj
 for bug-gnu-emacs@HIDDEN; Sat, 14 Nov 2020 11:31:50 -0500
Received: from mail-out.m-online.net ([212.18.0.10]:46004)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <whitebox@HIDDEN>)
 id 1kdySo-0001gD-IB
 for bug-gnu-emacs@HIDDEN; Sat, 14 Nov 2020 11:31:50 -0500
Received: from frontend01.mail.m-online.net (unknown [192.168.8.182])
 by mail-out.m-online.net (Postfix) with ESMTP id 4CYLSs4nzTz1rsMq;
 Sat, 14 Nov 2020 17:31:41 +0100 (CET)
Received: from localhost (dynscan1.mnet-online.de [192.168.6.70])
 by mail.m-online.net (Postfix) with ESMTP id 4CYLSs4Ygjz1qyX6;
 Sat, 14 Nov 2020 17:31:41 +0100 (CET)
X-Virus-Scanned: amavisd-new at mnet-online.de
Received: from mail.mnet-online.de ([192.168.8.182])
 by localhost (dynscan1.mail.m-online.net [192.168.6.70]) (amavisd-new,
 port 10024)
 with ESMTP id 6d5IeshrTMZU; Sat, 14 Nov 2020 17:31:40 +0100 (CET)
X-Auth-Info: qDu1ID8clROfpuuEkkNe6mmSUOPpyivQ6fGlbnkr+Lzpq3sdTdgrOK2//iPDnesN
Received: from igel.home (ppp-46-244-179-214.dynamic.mnet-online.de
 [46.244.179.214])
 (using TLSv1.2 with cipher ECDHE-RSA-AES256-GCM-SHA384 (256/256 bits))
 (No client certificate requested)
 by mail.mnet-online.de (Postfix) with ESMTPSA;
 Sat, 14 Nov 2020 17:31:40 +0100 (CET)
Received: by igel.home (Postfix, from userid 1000)
 id 477B72C334E; Sat, 14 Nov 2020 17:31:40 +0100 (CET)
From: Andreas Schwab <schwab@HIDDEN>
To: Daniel Lenski <dlenski@HIDDEN>
Subject: Re: [PATCH v2] speedbar bugfix: only replace '~/' when it appears
 at the beginning of the path
References: <87y2j5tvql.fsf@HIDDEN>
 <20201113185138.1333727-1-dlenski@HIDDEN>
X-Yow: I want DUSTIN HOFFMAN!! .. I want LIBERACE!!  YOW!!
Date: Sat, 14 Nov 2020 17:31:40 +0100
In-Reply-To: <20201113185138.1333727-1-dlenski@HIDDEN> (Daniel Lenski's
 message of "Fri, 13 Nov 2020 10:51:38 -0800")
Message-ID: <87eekvlx1v.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/27.1 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
Received-SPF: pass client-ip=212.18.0.10; envelope-from=whitebox@HIDDEN;
 helo=mail-out.m-online.net
X-detected-operating-system: by eggs.gnu.org: First seen = 2020/11/14 11:31:41
X-ACL-Warn: Detected OS   = Linux 3.11 and newer [fuzzy]
X-Spam_score_int: -22
X-Spam_score: -2.3
X-Spam_bar: --
X-Spam_report: (-2.3 / 5.0 requ) BAYES_00=-1.9,
 HEADER_FROM_DIFFERENT_DOMAINS=0.249, RCVD_IN_DNSWL_LOW=-0.7,
 RCVD_IN_MSPIKE_H3=0.001, RCVD_IN_MSPIKE_WL=0.001, SPF_HELO_NONE=0.001,
 SPF_PASS=-0.001 autolearn=ham autolearn_force=no
X-Spam_action: no action
X-Spam-Score: -1.1 (-)
X-Debbugs-Envelope-To: submit
Cc: bug-gnu-emacs@HIDDEN
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.1 (--)

On Nov 13 2020, Daniel Lenski wrote:

> diff --git a/lisp/speedbar.el b/lisp/speedbar.el
> index 991c8a33d4..3619b23d9e 100644
> --- a/lisp/speedbar.el
> +++ b/lisp/speedbar.el
> @@ -1874,9 +1874,9 @@ matches the user directory ~, then it is replaced with a ~.
>  INDEX is not used, but is required by the caller."
>    (let* ((tilde (expand-file-name "~/"))
>  	 (dd (expand-file-name directory))
> -	 (junk (string-match (regexp-quote tilde) dd))
> +	 (junk (string-prefix-p "~/" dd))

That should match tilde, not "~/" (which will never match).

Andreas.

-- 
Andreas Schwab, schwab@HIDDEN
GPG Key fingerprint = 7578 EB47 D4E5 4D69 2510  2552 DF73 E780 A9DA AEC1
"And now for something completely different."




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#44622; Package emacs. Full text available.
Forcibly Merged 44608 44622. Request was from Lars Ingebrigtsen <larsi@HIDDEN> to control <at> debbugs.gnu.org. Full text available.
bug marked as fixed in version 28.1, send any further explanations to 44622 <at> debbugs.gnu.org and Daniel Lenski <dlenski@HIDDEN> Request was from Lars Ingebrigtsen <larsi@HIDDEN> to control <at> debbugs.gnu.org. Full text available.
Added tag(s) fixed. Request was from Lars Ingebrigtsen <larsi@HIDDEN> to control <at> debbugs.gnu.org. Full text available.

Message received at 44622 <at> debbugs.gnu.org:


Received: (at 44622) by debbugs.gnu.org; 14 Nov 2020 16:08:17 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Sat Nov 14 11:08:16 2020
Received: from localhost ([127.0.0.1]:51684 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kdy64-0004kx-ML
	for submit <at> debbugs.gnu.org; Sat, 14 Nov 2020 11:08:16 -0500
Received: from quimby.gnus.org ([95.216.78.240]:44022)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <larsi@HIDDEN>) id 1kdy62-0004kj-S9
 for 44622 <at> debbugs.gnu.org; Sat, 14 Nov 2020 11:08:15 -0500
DKIM-Signature: v=1; a=rsa-sha256; q=dns/txt; c=relaxed/relaxed; d=gnus.org;
 s=20200322; h=Content-Type:MIME-Version:Message-ID:In-Reply-To:Date:
 References:Subject:Cc:To:From:Sender:Reply-To:Content-Transfer-Encoding:
 Content-ID:Content-Description:Resent-Date:Resent-From:Resent-Sender:
 Resent-To:Resent-Cc:Resent-Message-ID:List-Id:List-Help:List-Unsubscribe:
 List-Subscribe:List-Post:List-Owner:List-Archive;
 bh=QtegXwZPLZdD2OnECA3else5LTIR9OEnYKejQvuNwLY=; b=d9AQtxoIMoxzlkKgWnNdjjQWvA
 JyCCJKaZ7WrgHsgnIU4N1qtootYPKJiMJKIe4zueqvCEzrkakOa9iiNO6cQCCS4wCpTCDAP/NyPJD
 4ACXtanOfppjAM3KDHF1ngwAPmlt1Gw/5s/9hroDSkhZliURU4EMNXzH3btjTEvkCs5Q=;
Received: from cm-84.212.202.86.getinternet.no ([84.212.202.86] helo=xo)
 by quimby.gnus.org with esmtpsa (TLS1.3:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.92) (envelope-from <larsi@HIDDEN>)
 id 1kdy5s-0000TF-7D; Sat, 14 Nov 2020 17:08:09 +0100
From: Lars Ingebrigtsen <larsi@HIDDEN>
To: Daniel Lenski <dlenski@HIDDEN>
Subject: Re: bug#44622: [PATCH v2] speedbar bugfix: only replace '~/' when
 it appears at the beginning of the path
References: <87y2j5tvql.fsf@HIDDEN>
 <20201113185138.1333727-1-dlenski@HIDDEN>
X-Now-Playing: Genesis's _Duke_: "Heathaze"
Date: Sat, 14 Nov 2020 17:08:03 +0100
In-Reply-To: <20201113185138.1333727-1-dlenski@HIDDEN> (Daniel Lenski's
 message of "Fri, 13 Nov 2020 10:51:38 -0800")
Message-ID: <87eekvzzto.fsf@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/28.0.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Report: Spam detection software, running on the system "quimby.gnus.org",
 has NOT identified this incoming email as spam.  The original
 message has been attached to this so you can view it or label
 similar future email.  If you have any questions, see
 @@CONTACT_ADDRESS@@ for details.
 Content preview: Daniel Lenski <dlenski@HIDDEN> writes: > This makes
 Speedbar
 work correctly with remote directories accessed > through TRAMP. This bug
 has apparently been known for a long time: >
 https://cedet-devel.narkive.com/eIs7LoWB/speedbar-and-tramp
 [...] Content analysis details:   (-2.9 points, 5.0 required)
 pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -1.0 ALL_TRUSTED            Passed through trusted hosts only via SMTP
 -1.9 BAYES_00               BODY: Bayes spam probability is 0 to 1%
 [score: 0.0000]
X-Spam-Score: 0.0 (/)
X-Debbugs-Envelope-To: 44622
Cc: Andreas Schwab <schwab@HIDDEN>, 44622 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -1.0 (-)

Daniel Lenski <dlenski@HIDDEN> writes:

> This makes Speedbar work correctly with remote directories accessed
> through TRAMP. This bug has apparently been known for a long time:
> https://cedet-devel.narkive.com/eIs7LoWB/speedbar-and-tramp#post2

Thanks; applied to Emacs 28.

-- 
(domestic pets only, the antidote for overdose, milk.)
   bloggy blog: http://lars.ingebrigtsen.no




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#44622; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 13 Nov 2020 18:54:31 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Fri Nov 13 13:54:31 2020
Received: from localhost ([127.0.0.1]:49349 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.84_2)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1kdeDP-0002yK-1l
	for submit <at> debbugs.gnu.org; Fri, 13 Nov 2020 13:54:31 -0500
Received: from lists.gnu.org ([209.51.188.17]:51476)
 by debbugs.gnu.org with esmtp (Exim 4.84_2)
 (envelope-from <dlenski@HIDDEN>) id 1kdeDM-0002yA-B9
 for submit <at> debbugs.gnu.org; Fri, 13 Nov 2020 13:54:29 -0500
Received: from eggs.gnu.org ([2001:470:142:3::10]:50446)
 by lists.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_256_GCM_SHA384:256)
 (Exim 4.90_1) (envelope-from <dlenski@HIDDEN>) id 1kdeDM-0002U6-2i
 for bug-gnu-emacs@HIDDEN; Fri, 13 Nov 2020 13:54:28 -0500
Received: from mail-pg1-x543.google.com ([2607:f8b0:4864:20::543]:38024)
 by eggs.gnu.org with esmtps (TLS1.2:ECDHE_RSA_AES_128_GCM_SHA256:128)
 (Exim 4.90_1) (envelope-from <dlenski@HIDDEN>) id 1kdeDK-0003Iv-3W
 for bug-gnu-emacs@HIDDEN; Fri, 13 Nov 2020 13:54:27 -0500
Received: by mail-pg1-x543.google.com with SMTP id j19so1008979pgg.5
 for <bug-gnu-emacs@HIDDEN>; Fri, 13 Nov 2020 10:54:25 -0800 (PST)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20161025;
 h=from:to:cc:subject:date:message-id:in-reply-to:references;
 bh=L5FzFO9EfOV8aHN4jN9sm8/5chsFLOknc3jmSCfnUQ8=;
 b=bWogUYQfirWnswe1kJV7iVWryqIiVtyCqST6eIiuj7onV0RPbOufmZDA/d6KEUCP75
 az/0xEfHlTu+sngIowG+x9n/fRn+MZP0pLEc78Dxxp1+sOo6N4Q9KdY0wHpMp8ZSLEio
 5KVo350zNUq233yJTwTPl/Xncd4Lm7UaELVsrPB1ns2atolNAhpdUWl1PpAM61EGtQD5
 SsI+MhlBwGrHyBX4zxiiFo73q95KHjKwpsSUKEHOQ/Zop4GCQNiN0Wtp/BmFLfMl1QtD
 XxjJK1C/UHHSpVxwR7i8HofXyDQMy7gYqN3ka9nRyaYtm8jR/ITvyirLnZR65JCbYKbI
 OusQ==
X-Google-DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed;
 d=1e100.net; s=20161025;
 h=x-gm-message-state:from:to:cc:subject:date:message-id:in-reply-to
 :references;
 bh=L5FzFO9EfOV8aHN4jN9sm8/5chsFLOknc3jmSCfnUQ8=;
 b=qhp34xdiJ03MakvP0jx5D7B67HIran69UT8pRMVCrcpf9Fmk3wwqS0XmvnSQpwL7l1
 scS7QXH8p4WkMtG/kLJhxzI5lfSym0jMmhEkCzDyKQaewzVJZtfgxPdxn/kJjV4Mm7zP
 F2Y2IPvgnL7RrFRpkrrn9HrJFjE0nB+tfJlS4IHo3R0SPNqNld2HE6BsAHhW2Z73WJRT
 JwbXrajS3Q1OrYycQTKxkYdkgB7AWpsjNEf4slIRFQpjb33PDlZeB6fqo44DXHNr3crD
 rbUKHuoqe68dPp8zEZRpm2/5+Ax5HFaSxuqjMa3XRliCcEmJW5YjvtspvFT4iit/Wz3c
 syhg==
X-Gm-Message-State: AOAM530XKSmrgAMR8XeITDwy+3yHIgKdzIrCrhmEdoiHF8J5UyVhXcDZ
 Z02Js16vD1CQkr5fh7YcunYR2o5XxmCwhQ==
X-Google-Smtp-Source: ABdhPJzZIbCmAaT+9NlJaphtSo6awa4SSQBBvlI12kXsaXBeCHhm+SVs6NsaIMhaaY5nGTCIIJtkbA==
X-Received: by 2002:a17:90a:5908:: with SMTP id
 k8mr4371722pji.222.1605293664111; 
 Fri, 13 Nov 2020 10:54:24 -0800 (PST)
Received: from u0b6eedb2c9435b.ant.amazon.com
 ([2601:1c0:c:6da:a1b3:7e10:7b06:8308])
 by smtp.gmail.com with ESMTPSA id t16sm3712619pga.51.2020.11.13.10.54.23
 (version=TLS1_3 cipher=TLS_AES_256_GCM_SHA384 bits=256/256);
 Fri, 13 Nov 2020 10:54:23 -0800 (PST)
From: Daniel Lenski <dlenski@HIDDEN>
To: bug-gnu-emacs@HIDDEN
Subject: [PATCH v2] speedbar bugfix: only replace '~/' when it appears at the
 beginning of the path
Date: Fri, 13 Nov 2020 10:51:38 -0800
Message-Id: <20201113185138.1333727-1-dlenski@HIDDEN>
X-Mailer: git-send-email 2.17.1
In-Reply-To: <87y2j5tvql.fsf@HIDDEN>
References: <87y2j5tvql.fsf@HIDDEN>
Received-SPF: pass client-ip=2607:f8b0:4864:20::543;
 envelope-from=dlenski@HIDDEN; helo=mail-pg1-x543.google.com
X-detected-operating-system: by eggs.gnu.org: No matching host in p0f cache.
 That's all we know.
X-Spam_score_int: -20
X-Spam_score: -2.1
X-Spam_bar: --
X-Spam_report: (-2.1 / 5.0 requ) BAYES_00=-1.9, DKIM_SIGNED=0.1,
 DKIM_VALID=-0.1, DKIM_VALID_AU=-0.1, DKIM_VALID_EF=-0.1, FREEMAIL_FROM=0.001,
 RCVD_IN_DNSWL_NONE=-0.0001, SPF_HELO_NONE=0.001,
 SPF_PASS=-0.001 autolearn=ham autolearn_force=no
X-Spam_action: no action
X-Spam-Score: -1.3 (-)
X-Debbugs-Envelope-To: submit
Cc: Andreas Schwab <schwab@HIDDEN>, Daniel Lenski <dlenski@HIDDEN>
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.18
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <https://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <https://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit/>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <https://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>, 
 <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
Sender: "Debbugs-submit" <debbugs-submit-bounces <at> debbugs.gnu.org>
X-Spam-Score: -2.3 (--)

This makes Speedbar work correctly with remote directories accessed through TRAMP. This bug has apparently been known for a long time: https://cedet-devel.narkive.com/eIs7LoWB/speedbar-and-tramp#post2

Signed-off-by: Daniel Lenski <dlenski@HIDDEN>
---
 lisp/speedbar.el | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

diff --git a/lisp/speedbar.el b/lisp/speedbar.el
index 991c8a33d4..3619b23d9e 100644
--- a/lisp/speedbar.el
+++ b/lisp/speedbar.el
@@ -1874,9 +1874,9 @@ matches the user directory ~, then it is replaced with a ~.
 INDEX is not used, but is required by the caller."
   (let* ((tilde (expand-file-name "~/"))
 	 (dd (expand-file-name directory))
-	 (junk (string-match (regexp-quote tilde) dd))
+	 (junk (string-prefix-p "~/" dd))
 	 (displayme (if junk
-			(concat "~/" (substring dd (match-end 0)))
+			(concat "~/" (substring dd 2 nil))
 		      dd))
 	 (p (point)))
     (if (string-match "^~[/\\]?\\'" displayme) (setq displayme tilde))
-- 
2.17.1





Acknowledgement sent to Daniel Lenski <dlenski@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-gnu-emacs@HIDDEN. Full text available.
Report forwarded to bug-gnu-emacs@HIDDEN:
bug#44622; Package emacs. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Sat, 14 Nov 2020 17:00:02 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.